package cn.qinys.platform.upms.api.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import cn.qinys.platform.entity.upms.UpmsRole;
import cn.qinys.platform.upms.api.req.*;
import cn.qinys.platform.upms.api.resp.MenuSelectedResp;
import cn.qinys.platform.upms.api.resp.RoleMenusTreeResp;

import java.util.List;

/**
 * Description:
 *
 * @author tanlie
 * Date: 2024/2/27 11:10
 */
public interface IRoleService {

    /**
     * 角色分页
     *
     * @param req
     * @return
     */
    Page<UpmsRole> getRolePage(RolePageReq req);

    /**
     * 新增角色
     *
     * @param req
     */
    void createRole(RoleCreateReq req);

    /**
     * 修改角色
     *
     * @param req
     */
    void updateRole(RoleUpdateReq req);

    /**
     * 删除角色
     *
     * @param req
     */
    void removeRole(RoleRemoveReq req);

    /**
     * 获取角色列表
     *
     * @return
     */
    List<UpmsRole> getRoleList();

    /**
     * 权限码 给前端显示按钮用的
     *
     * @param superAdmin
     * @param roleId
     * @return
     */
    List<String> getPermissionCodes(String roleId,String superAdmin);

    /**
     * 支局数据权限
     * @param activeRole
     * @return
     */
    List<Integer> getPermissionDepartments(UpmsRole activeRole);

    /**
     * 更新用户激活的角色
     *
     * @param userId
     * @param roleId
     */
    void updateUserActiveRole(String userId, String roleId);


    /**
     * 菜单树
     *
     * @return
     */
    List<RoleMenusTreeResp> getMenusTree();

    /**
     * 已授权
     *
     * @param roleId
     * @return
     */
    MenuSelectedResp getMenuSelected(String roleId);

    /**
     * 新增权限
     *
     * @param req
     */
    void createResource(RoleMenuAuthReq req);

    /**
     * 权限码新增
     *
     * @param req
     */
    void createAuthPermission(RolePermissionReq req);
}
